# coding: utf-8

# flake8: noqa
"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import models into model package
from swagger_client.models.aws_auth_request import AWSAuthRequest
from swagger_client.models.awssm_request import AWSSMRequest
from swagger_client.models.awssm_response import AWSSMResponse
from swagger_client.models.account_creds_request import AccountCredsRequest
from swagger_client.models.account_type_request import AccountTypeRequest
from swagger_client.models.account_type_response import AccountTypeResponse
from swagger_client.models.active_resource_request import ActiveResourceRequest
from swagger_client.models.active_resource_response import ActiveResourceResponse
from swagger_client.models.add_artefact_version_payload_request import AddArtefactVersionPayloadRequest
from swagger_client.models.application_creation_request import ApplicationCreationRequest
from swagger_client.models.application_request import ApplicationRequest
from swagger_client.models.application_response import ApplicationResponse
from swagger_client.models.approval_request import ApprovalRequest
from swagger_client.models.artefact_request import ArtefactRequest
from swagger_client.models.artefact_response import ArtefactResponse
from swagger_client.models.artefact_version_request import ArtefactVersionRequest
from swagger_client.models.artefact_version_response import ArtefactVersionResponse
from swagger_client.models.automation_rule_request import AutomationRuleRequest
from swagger_client.models.automation_rule_response import AutomationRuleResponse
from swagger_client.models.azure_auth_request import AzureAuthRequest
from swagger_client.models.azure_kv_request import AzureKVRequest
from swagger_client.models.azure_kv_response import AzureKVResponse
from swagger_client.models.cluster_secret_request import ClusterSecretRequest
from swagger_client.models.cluster_secret_response import ClusterSecretResponse
from swagger_client.models.cluster_secrets_map_request import ClusterSecretsMapRequest
from swagger_client.models.cluster_secrets_map_response import ClusterSecretsMapResponse
from swagger_client.models.controller_request import ControllerRequest
from swagger_client.models.controller_response import ControllerResponse
from swagger_client.models.create_driver_request_request import CreateDriverRequestRequest
from swagger_client.models.create_resource_account_request_request import CreateResourceAccountRequestRequest
from swagger_client.models.create_resource_definition_request_request import CreateResourceDefinitionRequestRequest
from swagger_client.models.create_secret_store_payload_request import CreateSecretStorePayloadRequest
from swagger_client.models.delta_metadata_request import DeltaMetadataRequest
from swagger_client.models.delta_metadata_response import DeltaMetadataResponse
from swagger_client.models.delta_request import DeltaRequest
from swagger_client.models.delta_response import DeltaResponse
from swagger_client.models.deploy_condition_request import DeployConditionRequest
from swagger_client.models.deploy_condition_response import DeployConditionResponse
from swagger_client.models.deployment_error_request import DeploymentErrorRequest
from swagger_client.models.deployment_error_response import DeploymentErrorResponse
from swagger_client.models.deployment_request import DeploymentRequest
from swagger_client.models.deployment_response import DeploymentResponse
from swagger_client.models.driver_definition_request import DriverDefinitionRequest
from swagger_client.models.driver_definition_response import DriverDefinitionResponse
from swagger_client.models.environment_base_request import EnvironmentBaseRequest
from swagger_client.models.environment_base_response import EnvironmentBaseResponse
from swagger_client.models.environment_definition_request import EnvironmentDefinitionRequest
from swagger_client.models.environment_request import EnvironmentRequest
from swagger_client.models.environment_response import EnvironmentResponse
from swagger_client.models.environment_runtime_info_response import EnvironmentRuntimeInfoResponse
from swagger_client.models.environment_type_request import EnvironmentTypeRequest
from swagger_client.models.environment_type_response import EnvironmentTypeResponse
from swagger_client.models.error_info_response import ErrorInfoResponse
from swagger_client.models.error_response import ErrorResponse
from swagger_client.models.event_base_request import EventBaseRequest
from swagger_client.models.event_base_response import EventBaseResponse
from swagger_client.models.event_response import EventResponse
from swagger_client.models.gcp_auth_request import GCPAuthRequest
from swagger_client.models.gcpsm_request import GCPSMRequest
from swagger_client.models.gcpsm_response import GCPSMResponse
from swagger_client.models.humanitec_error_response import HumanitecErrorResponse
from swagger_client.models.humanitec_public_key import HumanitecPublicKey
from swagger_client.models.humanitec_request import HumanitecRequest
from swagger_client.models.humanitec_response import HumanitecResponse
from swagger_client.models.image_build_request import ImageBuildRequest
from swagger_client.models.image_build_response import ImageBuildResponse
from swagger_client.models.image_request import ImageRequest
from swagger_client.models.image_response import ImageResponse
from swagger_client.models.images_registry_creds_request import ImagesRegistryCredsRequest
from swagger_client.models.images_registry_creds_response import ImagesRegistryCredsResponse
from swagger_client.models.inline_response200 import InlineResponse200
from swagger_client.models.inline_response2001 import InlineResponse2001
from swagger_client.models.json_field_request import JSONFieldRequest
from swagger_client.models.json_field_response import JSONFieldResponse
from swagger_client.models.json_patch_request import JSONPatchRequest
from swagger_client.models.json_patch_response import JSONPatchResponse
from swagger_client.models.json_patches_response import JSONPatchesResponse
from swagger_client.models.logo_response import LogoResponse
from swagger_client.models.manifest_request import ManifestRequest
from swagger_client.models.manifest_response import ManifestResponse
from swagger_client.models.matching_criteria_request import MatchingCriteriaRequest
from swagger_client.models.matching_criteria_response import MatchingCriteriaResponse
from swagger_client.models.matching_criteria_rule_request import MatchingCriteriaRuleRequest
from swagger_client.models.module_deltas_request import ModuleDeltasRequest
from swagger_client.models.module_deltas_response import ModuleDeltasResponse
from swagger_client.models.module_request import ModuleRequest
from swagger_client.models.module_response import ModuleResponse
from swagger_client.models.new_service_user_request import NewServiceUserRequest
from swagger_client.models.node_body_response import NodeBodyResponse
from swagger_client.models.org_id_workloadprofilechartversions_body import OrgIdWorkloadprofilechartversionsBody
from swagger_client.models.organization_request import OrganizationRequest
from swagger_client.models.organization_response import OrganizationResponse
from swagger_client.models.patch_resource_definition_request_request import PatchResourceDefinitionRequestRequest
from swagger_client.models.pipeline import Pipeline
from swagger_client.models.pipeline_version import PipelineVersion
from swagger_client.models.plain_delta_response import PlainDeltaResponse
from swagger_client.models.pod_state_request import PodStateRequest
from swagger_client.models.pod_state_response import PodStateResponse
from swagger_client.models.provision_dependencies_request import ProvisionDependenciesRequest
from swagger_client.models.provision_dependencies_response import ProvisionDependenciesResponse
from swagger_client.models.public_key import PublicKey
from swagger_client.models.registry_creds_response import RegistryCredsResponse
from swagger_client.models.registry_request import RegistryRequest
from swagger_client.models.registry_response import RegistryResponse
from swagger_client.models.resource_account_request import ResourceAccountRequest
from swagger_client.models.resource_account_response import ResourceAccountResponse
from swagger_client.models.resource_definition_change_response import ResourceDefinitionChangeResponse
from swagger_client.models.resource_definition_request import ResourceDefinitionRequest
from swagger_client.models.resource_definition_response import ResourceDefinitionResponse
from swagger_client.models.resource_provision_request_request import ResourceProvisionRequestRequest
from swagger_client.models.resource_type_request import ResourceTypeRequest
from swagger_client.models.resource_type_response import ResourceTypeResponse
from swagger_client.models.role_request import RoleRequest
from swagger_client.models.run_create_request import RunCreateRequest
from swagger_client.models.run_job_list_response import RunJobListResponse
from swagger_client.models.run_job_response import RunJobResponse
from swagger_client.models.run_job_step import RunJobStep
from swagger_client.models.run_job_step_log import RunJobStepLog
from swagger_client.models.run_response import RunResponse
from swagger_client.models.runtime_info_request import RuntimeInfoRequest
from swagger_client.models.runtime_info_response import RuntimeInfoResponse
from swagger_client.models.secret_reference import SecretReference
from swagger_client.models.secret_store_request import SecretStoreRequest
from swagger_client.models.secret_store_response import SecretStoreResponse
from swagger_client.models.set_request import SetRequest
from swagger_client.models.set_response import SetResponse
from swagger_client.models.token_definition_request import TokenDefinitionRequest
from swagger_client.models.token_info_request import TokenInfoRequest
from swagger_client.models.token_info_response import TokenInfoResponse
from swagger_client.models.token_response import TokenResponse
from swagger_client.models.update_action_request import UpdateActionRequest
from swagger_client.models.update_action_response import UpdateActionResponse
from swagger_client.models.update_artefact_version_payload_request import UpdateArtefactVersionPayloadRequest
from swagger_client.models.update_driver_request_request import UpdateDriverRequestRequest
from swagger_client.models.update_resource_account_request_request import UpdateResourceAccountRequestRequest
from swagger_client.models.update_resource_definition_request_request import UpdateResourceDefinitionRequestRequest
from swagger_client.models.update_secret_store_payload_request import UpdateSecretStorePayloadRequest
from swagger_client.models.user_invite_request_request import UserInviteRequestRequest
from swagger_client.models.user_invite_response import UserInviteResponse
from swagger_client.models.user_profile_extended_request import UserProfileExtendedRequest
from swagger_client.models.user_profile_extended_response import UserProfileExtendedResponse
from swagger_client.models.user_profile_request import UserProfileRequest
from swagger_client.models.user_profile_response import UserProfileResponse
from swagger_client.models.user_role_request import UserRoleRequest
from swagger_client.models.user_role_response import UserRoleResponse
from swagger_client.models.value_create_payload_request import ValueCreatePayloadRequest
from swagger_client.models.value_edit_payload_request import ValueEditPayloadRequest
from swagger_client.models.value_patch_payload_request import ValuePatchPayloadRequest
from swagger_client.models.value_request import ValueRequest
from swagger_client.models.value_response import ValueResponse
from swagger_client.models.value_set_action_payload_request import ValueSetActionPayloadRequest
from swagger_client.models.value_set_response import ValueSetResponse
from swagger_client.models.value_set_version_response import ValueSetVersionResponse
from swagger_client.models.value_set_version_result_of import ValueSetVersionResultOf
from swagger_client.models.value_source import ValueSource
from swagger_client.models.values_secrets_refs_request import ValuesSecretsRefsRequest
from swagger_client.models.values_secrets_refs_response import ValuesSecretsRefsResponse
from swagger_client.models.vault_auth_request import VaultAuthRequest
from swagger_client.models.vault_request import VaultRequest
from swagger_client.models.vault_response import VaultResponse
from swagger_client.models.webhook_request import WebhookRequest
from swagger_client.models.webhook_response import WebhookResponse
from swagger_client.models.webhook_update_response import WebhookUpdateResponse
from swagger_client.models.workload_profile_chart_reference import WorkloadProfileChartReference
from swagger_client.models.workload_profile_chart_version_response import WorkloadProfileChartVersionResponse
from swagger_client.models.workload_profile_request import WorkloadProfileRequest
from swagger_client.models.workload_profile_response import WorkloadProfileResponse
from swagger_client.models.workload_profile_version_request import WorkloadProfileVersionRequest
from swagger_client.models.workload_profile_version_response import WorkloadProfileVersionResponse
from swagger_client.models.workload_profile_version_spec_definition import WorkloadProfileVersionSpecDefinition
from swagger_client.models.workload_profile_version_spec_definition_properties import WorkloadProfileVersionSpecDefinitionProperties
from swagger_client.models.workload_profile_version_spec_definition_property import WorkloadProfileVersionSpecDefinitionProperty
from swagger_client.models.workload_profile_version_spec_definition_property_type import WorkloadProfileVersionSpecDefinitionPropertyType
from swagger_client.models.workload_profile_version_spec_definition_property_ui_hints import WorkloadProfileVersionSpecDefinitionPropertyUIHints
from swagger_client.models.workload_profile_version_spec_definition_runtime_property import WorkloadProfileVersionSpecDefinitionRuntimeProperty
from swagger_client.models.workload_profile_version_spec_definition_runtime_property_type import WorkloadProfileVersionSpecDefinitionRuntimePropertyType
