# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeltaMetadataResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'archived': 'bool',
        'contributers': 'list[str]',
        'created_at': 'datetime',
        'created_by': 'str',
        'env_id': 'str',
        'last_modified_at': 'datetime',
        'name': 'str',
        'shared': 'bool'
    }

    attribute_map = {
        'archived': 'archived',
        'contributers': 'contributers',
        'created_at': 'created_at',
        'created_by': 'created_by',
        'env_id': 'env_id',
        'last_modified_at': 'last_modified_at',
        'name': 'name',
        'shared': 'shared'
    }

    def __init__(self, archived=None, contributers=None, created_at=None, created_by=None, env_id=None, last_modified_at=None, name=None, shared=None):  # noqa: E501
        """DeltaMetadataResponse - a model defined in Swagger"""  # noqa: E501
        self._archived = None
        self._contributers = None
        self._created_at = None
        self._created_by = None
        self._env_id = None
        self._last_modified_at = None
        self._name = None
        self._shared = None
        self.discriminator = None
        self.archived = archived
        if contributers is not None:
            self.contributers = contributers
        self.created_at = created_at
        self.created_by = created_by
        if env_id is not None:
            self.env_id = env_id
        self.last_modified_at = last_modified_at
        if name is not None:
            self.name = name
        if shared is not None:
            self.shared = shared

    @property
    def archived(self):
        """Gets the archived of this DeltaMetadataResponse.  # noqa: E501


        :return: The archived of this DeltaMetadataResponse.  # noqa: E501
        :rtype: bool
        """
        return self._archived

    @archived.setter
    def archived(self, archived):
        """Sets the archived of this DeltaMetadataResponse.


        :param archived: The archived of this DeltaMetadataResponse.  # noqa: E501
        :type: bool
        """
        if archived is None:
            raise ValueError("Invalid value for `archived`, must not be `None`")  # noqa: E501

        self._archived = archived

    @property
    def contributers(self):
        """Gets the contributers of this DeltaMetadataResponse.  # noqa: E501


        :return: The contributers of this DeltaMetadataResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._contributers

    @contributers.setter
    def contributers(self, contributers):
        """Sets the contributers of this DeltaMetadataResponse.


        :param contributers: The contributers of this DeltaMetadataResponse.  # noqa: E501
        :type: list[str]
        """

        self._contributers = contributers

    @property
    def created_at(self):
        """Gets the created_at of this DeltaMetadataResponse.  # noqa: E501


        :return: The created_at of this DeltaMetadataResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this DeltaMetadataResponse.


        :param created_at: The created_at of this DeltaMetadataResponse.  # noqa: E501
        :type: datetime
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this DeltaMetadataResponse.  # noqa: E501


        :return: The created_by of this DeltaMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this DeltaMetadataResponse.


        :param created_by: The created_by of this DeltaMetadataResponse.  # noqa: E501
        :type: str
        """
        if created_by is None:
            raise ValueError("Invalid value for `created_by`, must not be `None`")  # noqa: E501

        self._created_by = created_by

    @property
    def env_id(self):
        """Gets the env_id of this DeltaMetadataResponse.  # noqa: E501


        :return: The env_id of this DeltaMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._env_id

    @env_id.setter
    def env_id(self, env_id):
        """Sets the env_id of this DeltaMetadataResponse.


        :param env_id: The env_id of this DeltaMetadataResponse.  # noqa: E501
        :type: str
        """

        self._env_id = env_id

    @property
    def last_modified_at(self):
        """Gets the last_modified_at of this DeltaMetadataResponse.  # noqa: E501


        :return: The last_modified_at of this DeltaMetadataResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_at

    @last_modified_at.setter
    def last_modified_at(self, last_modified_at):
        """Sets the last_modified_at of this DeltaMetadataResponse.


        :param last_modified_at: The last_modified_at of this DeltaMetadataResponse.  # noqa: E501
        :type: datetime
        """
        if last_modified_at is None:
            raise ValueError("Invalid value for `last_modified_at`, must not be `None`")  # noqa: E501

        self._last_modified_at = last_modified_at

    @property
    def name(self):
        """Gets the name of this DeltaMetadataResponse.  # noqa: E501


        :return: The name of this DeltaMetadataResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeltaMetadataResponse.


        :param name: The name of this DeltaMetadataResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def shared(self):
        """Gets the shared of this DeltaMetadataResponse.  # noqa: E501


        :return: The shared of this DeltaMetadataResponse.  # noqa: E501
        :rtype: bool
        """
        return self._shared

    @shared.setter
    def shared(self, shared):
        """Sets the shared of this DeltaMetadataResponse.


        :param shared: The shared of this DeltaMetadataResponse.  # noqa: E501
        :type: bool
        """

        self._shared = shared

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeltaMetadataResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeltaMetadataResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
