# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DriverDefinitionRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_types': 'list[str]',
        'id': 'str',
        'inputs_schema': 'dict(str, object)',
        'org_id': 'str',
        'target': 'str',
        'template': 'object',
        'type': 'str'
    }

    attribute_map = {
        'account_types': 'account_types',
        'id': 'id',
        'inputs_schema': 'inputs_schema',
        'org_id': 'org_id',
        'target': 'target',
        'template': 'template',
        'type': 'type'
    }

    def __init__(self, account_types=None, id=None, inputs_schema=None, org_id=None, target=None, template=None, type=None):  # noqa: E501
        """DriverDefinitionRequest - a model defined in Swagger"""  # noqa: E501
        self._account_types = None
        self._id = None
        self._inputs_schema = None
        self._org_id = None
        self._target = None
        self._template = None
        self._type = None
        self.discriminator = None
        if account_types is not None:
            self.account_types = account_types
        if id is not None:
            self.id = id
        if inputs_schema is not None:
            self.inputs_schema = inputs_schema
        if org_id is not None:
            self.org_id = org_id
        if target is not None:
            self.target = target
        if template is not None:
            self.template = template
        if type is not None:
            self.type = type

    @property
    def account_types(self):
        """Gets the account_types of this DriverDefinitionRequest.  # noqa: E501

        List of resources accounts types supported by the driver  # noqa: E501

        :return: The account_types of this DriverDefinitionRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._account_types

    @account_types.setter
    def account_types(self, account_types):
        """Sets the account_types of this DriverDefinitionRequest.

        List of resources accounts types supported by the driver  # noqa: E501

        :param account_types: The account_types of this DriverDefinitionRequest.  # noqa: E501
        :type: list[str]
        """

        self._account_types = account_types

    @property
    def id(self):
        """Gets the id of this DriverDefinitionRequest.  # noqa: E501

        The ID for this driver. Is used as `driver_type`.  # noqa: E501

        :return: The id of this DriverDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DriverDefinitionRequest.

        The ID for this driver. Is used as `driver_type`.  # noqa: E501

        :param id: The id of this DriverDefinitionRequest.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def inputs_schema(self):
        """Gets the inputs_schema of this DriverDefinitionRequest.  # noqa: E501

        A JSON Schema specifying the driver-specific input parameters.  # noqa: E501

        :return: The inputs_schema of this DriverDefinitionRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._inputs_schema

    @inputs_schema.setter
    def inputs_schema(self, inputs_schema):
        """Sets the inputs_schema of this DriverDefinitionRequest.

        A JSON Schema specifying the driver-specific input parameters.  # noqa: E501

        :param inputs_schema: The inputs_schema of this DriverDefinitionRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._inputs_schema = inputs_schema

    @property
    def org_id(self):
        """Gets the org_id of this DriverDefinitionRequest.  # noqa: E501

        The Organization this driver exists under. Useful as public drivers are accessible to other orgs.  # noqa: E501

        :return: The org_id of this DriverDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this DriverDefinitionRequest.

        The Organization this driver exists under. Useful as public drivers are accessible to other orgs.  # noqa: E501

        :param org_id: The org_id of this DriverDefinitionRequest.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def target(self):
        """Gets the target of this DriverDefinitionRequest.  # noqa: E501

        The prefix where the driver resides or, if the driver is a virtual driver, the reference to an existing driver using the `driver://` schema of the format `driver://{orgId}/{driverId}`. Only members of the organization the driver belongs to can see `target`.  # noqa: E501

        :return: The target of this DriverDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this DriverDefinitionRequest.

        The prefix where the driver resides or, if the driver is a virtual driver, the reference to an existing driver using the `driver://` schema of the format `driver://{orgId}/{driverId}`. Only members of the organization the driver belongs to can see `target`.  # noqa: E501

        :param target: The target of this DriverDefinitionRequest.  # noqa: E501
        :type: str
        """

        self._target = target

    @property
    def template(self):
        """Gets the template of this DriverDefinitionRequest.  # noqa: E501

        If the driver is a virtual driver, template defines a Go template that converts the driver inputs supplied in the resource definition into the driver inputs for the target driver.  # noqa: E501

        :return: The template of this DriverDefinitionRequest.  # noqa: E501
        :rtype: object
        """
        return self._template

    @template.setter
    def template(self, template):
        """Sets the template of this DriverDefinitionRequest.

        If the driver is a virtual driver, template defines a Go template that converts the driver inputs supplied in the resource definition into the driver inputs for the target driver.  # noqa: E501

        :param template: The template of this DriverDefinitionRequest.  # noqa: E501
        :type: object
        """

        self._template = template

    @property
    def type(self):
        """Gets the type of this DriverDefinitionRequest.  # noqa: E501

        The type of resource produced by this driver  # noqa: E501

        :return: The type of this DriverDefinitionRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DriverDefinitionRequest.

        The type of resource produced by this driver  # noqa: E501

        :param type: The type of this DriverDefinitionRequest.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DriverDefinitionRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DriverDefinitionRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
