# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RegistryResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'str',
        'created_by': 'str',
        'enable_ci': 'bool',
        'id': 'str',
        'registry': 'str',
        'secrets': 'ClusterSecretsMapResponse',
        'type': 'str'
    }

    attribute_map = {
        'created_at': 'created_at',
        'created_by': 'created_by',
        'enable_ci': 'enable_ci',
        'id': 'id',
        'registry': 'registry',
        'secrets': 'secrets',
        'type': 'type'
    }

    def __init__(self, created_at=None, created_by=None, enable_ci=None, id=None, registry=None, secrets=None, type=None):  # noqa: E501
        """RegistryResponse - a model defined in Swagger"""  # noqa: E501
        self._created_at = None
        self._created_by = None
        self._enable_ci = None
        self._id = None
        self._registry = None
        self._secrets = None
        self._type = None
        self.discriminator = None
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        self.enable_ci = enable_ci
        self.id = id
        self.registry = registry
        if secrets is not None:
            self.secrets = secrets
        self.type = type

    @property
    def created_at(self):
        """Gets the created_at of this RegistryResponse.  # noqa: E501

        The timestamp of when this record was created.  # noqa: E501

        :return: The created_at of this RegistryResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this RegistryResponse.

        The timestamp of when this record was created.  # noqa: E501

        :param created_at: The created_at of this RegistryResponse.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this RegistryResponse.  # noqa: E501

        The user who created this record.  # noqa: E501

        :return: The created_by of this RegistryResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this RegistryResponse.

        The user who created this record.  # noqa: E501

        :param created_by: The created_by of this RegistryResponse.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def enable_ci(self):
        """Gets the enable_ci of this RegistryResponse.  # noqa: E501

        Indicates if registry secrets and credentials should be exposed to CI agents.  # noqa: E501

        :return: The enable_ci of this RegistryResponse.  # noqa: E501
        :rtype: bool
        """
        return self._enable_ci

    @enable_ci.setter
    def enable_ci(self, enable_ci):
        """Sets the enable_ci of this RegistryResponse.

        Indicates if registry secrets and credentials should be exposed to CI agents.  # noqa: E501

        :param enable_ci: The enable_ci of this RegistryResponse.  # noqa: E501
        :type: bool
        """
        if enable_ci is None:
            raise ValueError("Invalid value for `enable_ci`, must not be `None`")  # noqa: E501

        self._enable_ci = enable_ci

    @property
    def id(self):
        """Gets the id of this RegistryResponse.  # noqa: E501

        Registry ID, unique within the Organization.  # noqa: E501

        :return: The id of this RegistryResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RegistryResponse.

        Registry ID, unique within the Organization.  # noqa: E501

        :param id: The id of this RegistryResponse.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def registry(self):
        """Gets the registry of this RegistryResponse.  # noqa: E501

        Registry name, usually in a \"{domain}\" or \"{domain}/{project}\" format.  # noqa: E501

        :return: The registry of this RegistryResponse.  # noqa: E501
        :rtype: str
        """
        return self._registry

    @registry.setter
    def registry(self, registry):
        """Sets the registry of this RegistryResponse.

        Registry name, usually in a \"{domain}\" or \"{domain}/{project}\" format.  # noqa: E501

        :param registry: The registry of this RegistryResponse.  # noqa: E501
        :type: str
        """
        if registry is None:
            raise ValueError("Invalid value for `registry`, must not be `None`")  # noqa: E501

        self._registry = registry

    @property
    def secrets(self):
        """Gets the secrets of this RegistryResponse.  # noqa: E501


        :return: The secrets of this RegistryResponse.  # noqa: E501
        :rtype: ClusterSecretsMapResponse
        """
        return self._secrets

    @secrets.setter
    def secrets(self, secrets):
        """Sets the secrets of this RegistryResponse.


        :param secrets: The secrets of this RegistryResponse.  # noqa: E501
        :type: ClusterSecretsMapResponse
        """

        self._secrets = secrets

    @property
    def type(self):
        """Gets the type of this RegistryResponse.  # noqa: E501

        Registry type, describes the registry authentication method, and defines the schema for the credentials.  Supported values:  - `public`  - `basic`  - `google_gcr`  - `amazon_ecr`  - `secret_ref`  # noqa: E501

        :return: The type of this RegistryResponse.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RegistryResponse.

        Registry type, describes the registry authentication method, and defines the schema for the credentials.  Supported values:  - `public`  - `basic`  - `google_gcr`  - `amazon_ecr`  - `secret_ref`  # noqa: E501

        :param type: The type of this RegistryResponse.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RegistryResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegistryResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
