# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RunResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'etag': 'str',
        'org_id': 'str',
        'app_id': 'str',
        'pipeline_id': 'str',
        'pipeline_version': 'str',
        'status': 'str',
        'status_message': 'str',
        'created_at': 'datetime',
        'executing_at': 'datetime',
        'cancellation_requested_at': 'datetime',
        'completed_at': 'datetime',
        'timeout_seconds': 'int',
        'inputs': 'dict(str, object)',
        'run_as': 'str',
        'concurrency_group': 'str',
        'waiting_for': 'dict(str, str)'
    }

    attribute_map = {
        'id': 'id',
        'etag': 'etag',
        'org_id': 'org_id',
        'app_id': 'app_id',
        'pipeline_id': 'pipeline_id',
        'pipeline_version': 'pipeline_version',
        'status': 'status',
        'status_message': 'status_message',
        'created_at': 'created_at',
        'executing_at': 'executing_at',
        'cancellation_requested_at': 'cancellation_requested_at',
        'completed_at': 'completed_at',
        'timeout_seconds': 'timeout_seconds',
        'inputs': 'inputs',
        'run_as': 'run_as',
        'concurrency_group': 'concurrency_group',
        'waiting_for': 'waiting_for'
    }

    def __init__(self, id=None, etag=None, org_id=None, app_id=None, pipeline_id=None, pipeline_version=None, status=None, status_message=None, created_at=None, executing_at=None, cancellation_requested_at=None, completed_at=None, timeout_seconds=None, inputs=None, run_as=None, concurrency_group=None, waiting_for=None):  # noqa: E501
        """RunResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._etag = None
        self._org_id = None
        self._app_id = None
        self._pipeline_id = None
        self._pipeline_version = None
        self._status = None
        self._status_message = None
        self._created_at = None
        self._executing_at = None
        self._cancellation_requested_at = None
        self._completed_at = None
        self._timeout_seconds = None
        self._inputs = None
        self._run_as = None
        self._concurrency_group = None
        self._waiting_for = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if etag is not None:
            self.etag = etag
        if org_id is not None:
            self.org_id = org_id
        if app_id is not None:
            self.app_id = app_id
        if pipeline_id is not None:
            self.pipeline_id = pipeline_id
        if pipeline_version is not None:
            self.pipeline_version = pipeline_version
        if status is not None:
            self.status = status
        if status_message is not None:
            self.status_message = status_message
        if created_at is not None:
            self.created_at = created_at
        if executing_at is not None:
            self.executing_at = executing_at
        if cancellation_requested_at is not None:
            self.cancellation_requested_at = cancellation_requested_at
        if completed_at is not None:
            self.completed_at = completed_at
        if timeout_seconds is not None:
            self.timeout_seconds = timeout_seconds
        if inputs is not None:
            self.inputs = inputs
        if run_as is not None:
            self.run_as = run_as
        if concurrency_group is not None:
            self.concurrency_group = concurrency_group
        self.waiting_for = waiting_for

    @property
    def id(self):
        """Gets the id of this RunResponse.  # noqa: E501

        The unique id of the Run.  # noqa: E501

        :return: The id of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RunResponse.

        The unique id of the Run.  # noqa: E501

        :param id: The id of this RunResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def etag(self):
        """Gets the etag of this RunResponse.  # noqa: E501

        The current entity tag value for this Run.  # noqa: E501

        :return: The etag of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """Sets the etag of this RunResponse.

        The current entity tag value for this Run.  # noqa: E501

        :param etag: The etag of this RunResponse.  # noqa: E501
        :type: str
        """

        self._etag = etag

    @property
    def org_id(self):
        """Gets the org_id of this RunResponse.  # noqa: E501

        The id of the Organization containing this Run.  # noqa: E501

        :return: The org_id of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this RunResponse.

        The id of the Organization containing this Run.  # noqa: E501

        :param org_id: The org_id of this RunResponse.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def app_id(self):
        """Gets the app_id of this RunResponse.  # noqa: E501

        The id of the Application containing this Run.  # noqa: E501

        :return: The app_id of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this RunResponse.

        The id of the Application containing this Run.  # noqa: E501

        :param app_id: The app_id of this RunResponse.  # noqa: E501
        :type: str
        """

        self._app_id = app_id

    @property
    def pipeline_id(self):
        """Gets the pipeline_id of this RunResponse.  # noqa: E501

        The id of the Pipeline associated with the Run.  # noqa: E501

        :return: The pipeline_id of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_id

    @pipeline_id.setter
    def pipeline_id(self, pipeline_id):
        """Sets the pipeline_id of this RunResponse.

        The id of the Pipeline associated with the Run.  # noqa: E501

        :param pipeline_id: The pipeline_id of this RunResponse.  # noqa: E501
        :type: str
        """

        self._pipeline_id = pipeline_id

    @property
    def pipeline_version(self):
        """Gets the pipeline_version of this RunResponse.  # noqa: E501

        The id of the Pipeline Version associated with the Run.  # noqa: E501

        :return: The pipeline_version of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_version

    @pipeline_version.setter
    def pipeline_version(self, pipeline_version):
        """Sets the pipeline_version of this RunResponse.

        The id of the Pipeline Version associated with the Run.  # noqa: E501

        :param pipeline_version: The pipeline_version of this RunResponse.  # noqa: E501
        :type: str
        """

        self._pipeline_version = pipeline_version

    @property
    def status(self):
        """Gets the status of this RunResponse.  # noqa: E501

        The current status of this Run.  # noqa: E501

        :return: The status of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this RunResponse.

        The current status of this Run.  # noqa: E501

        :param status: The status of this RunResponse.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def status_message(self):
        """Gets the status_message of this RunResponse.  # noqa: E501

        A human-readable message indicating the reason for the status.  # noqa: E501

        :return: The status_message of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._status_message

    @status_message.setter
    def status_message(self, status_message):
        """Sets the status_message of this RunResponse.

        A human-readable message indicating the reason for the status.  # noqa: E501

        :param status_message: The status_message of this RunResponse.  # noqa: E501
        :type: str
        """

        self._status_message = status_message

    @property
    def created_at(self):
        """Gets the created_at of this RunResponse.  # noqa: E501

        The date and time when this Run was first created.  # noqa: E501

        :return: The created_at of this RunResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this RunResponse.

        The date and time when this Run was first created.  # noqa: E501

        :param created_at: The created_at of this RunResponse.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def executing_at(self):
        """Gets the executing_at of this RunResponse.  # noqa: E501

        The date and time when this Run entered executing status.  # noqa: E501

        :return: The executing_at of this RunResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._executing_at

    @executing_at.setter
    def executing_at(self, executing_at):
        """Sets the executing_at of this RunResponse.

        The date and time when this Run entered executing status.  # noqa: E501

        :param executing_at: The executing_at of this RunResponse.  # noqa: E501
        :type: datetime
        """

        self._executing_at = executing_at

    @property
    def cancellation_requested_at(self):
        """Gets the cancellation_requested_at of this RunResponse.  # noqa: E501

        The date and time when cancellation of this Run was requested.  # noqa: E501

        :return: The cancellation_requested_at of this RunResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._cancellation_requested_at

    @cancellation_requested_at.setter
    def cancellation_requested_at(self, cancellation_requested_at):
        """Sets the cancellation_requested_at of this RunResponse.

        The date and time when cancellation of this Run was requested.  # noqa: E501

        :param cancellation_requested_at: The cancellation_requested_at of this RunResponse.  # noqa: E501
        :type: datetime
        """

        self._cancellation_requested_at = cancellation_requested_at

    @property
    def completed_at(self):
        """Gets the completed_at of this RunResponse.  # noqa: E501

        The date and time when this Run entered a successful, failed, or cancelled status.  # noqa: E501

        :return: The completed_at of this RunResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._completed_at

    @completed_at.setter
    def completed_at(self, completed_at):
        """Sets the completed_at of this RunResponse.

        The date and time when this Run entered a successful, failed, or cancelled status.  # noqa: E501

        :param completed_at: The completed_at of this RunResponse.  # noqa: E501
        :type: datetime
        """

        self._completed_at = completed_at

    @property
    def timeout_seconds(self):
        """Gets the timeout_seconds of this RunResponse.  # noqa: E501

        The timeout for this Run.  # noqa: E501

        :return: The timeout_seconds of this RunResponse.  # noqa: E501
        :rtype: int
        """
        return self._timeout_seconds

    @timeout_seconds.setter
    def timeout_seconds(self, timeout_seconds):
        """Sets the timeout_seconds of this RunResponse.

        The timeout for this Run.  # noqa: E501

        :param timeout_seconds: The timeout_seconds of this RunResponse.  # noqa: E501
        :type: int
        """

        self._timeout_seconds = timeout_seconds

    @property
    def inputs(self):
        """Gets the inputs of this RunResponse.  # noqa: E501

        The inputs that were provided for this Run.  # noqa: E501

        :return: The inputs of this RunResponse.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this RunResponse.

        The inputs that were provided for this Run.  # noqa: E501

        :param inputs: The inputs of this RunResponse.  # noqa: E501
        :type: dict(str, object)
        """

        self._inputs = inputs

    @property
    def run_as(self):
        """Gets the run_as of this RunResponse.  # noqa: E501

        The user id that the pipeline run is executing as when it calls Humanitec APIs.  # noqa: E501

        :return: The run_as of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._run_as

    @run_as.setter
    def run_as(self, run_as):
        """Sets the run_as of this RunResponse.

        The user id that the pipeline run is executing as when it calls Humanitec APIs.  # noqa: E501

        :param run_as: The run_as of this RunResponse.  # noqa: E501
        :type: str
        """

        self._run_as = run_as

    @property
    def concurrency_group(self):
        """Gets the concurrency_group of this RunResponse.  # noqa: E501

        The optional concurrency group for this run within the application  # noqa: E501

        :return: The concurrency_group of this RunResponse.  # noqa: E501
        :rtype: str
        """
        return self._concurrency_group

    @concurrency_group.setter
    def concurrency_group(self, concurrency_group):
        """Sets the concurrency_group of this RunResponse.

        The optional concurrency group for this run within the application  # noqa: E501

        :param concurrency_group: The concurrency_group of this RunResponse.  # noqa: E501
        :type: str
        """

        self._concurrency_group = concurrency_group

    @property
    def waiting_for(self):
        """Gets the waiting_for of this RunResponse.  # noqa: E501

        Aggregated events on which run's jobs are waiting for  # noqa: E501

        :return: The waiting_for of this RunResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._waiting_for

    @waiting_for.setter
    def waiting_for(self, waiting_for):
        """Sets the waiting_for of this RunResponse.

        Aggregated events on which run's jobs are waiting for  # noqa: E501

        :param waiting_for: The waiting_for of this RunResponse.  # noqa: E501
        :type: dict(str, str)
        """
        if waiting_for is None:
            raise ValueError("Invalid value for `waiting_for`, must not be `None`")  # noqa: E501

        self._waiting_for = waiting_for

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RunResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RunResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
