# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SecretStoreRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'awssm': 'AWSSMRequest',
        'azurekv': 'AzureKVRequest',
        'created_at': 'str',
        'created_by': 'str',
        'gcpsm': 'GCPSMRequest',
        'humanitec': 'HumanitecRequest',
        'id': 'str',
        'primary': 'bool',
        'updated_at': 'str',
        'updated_by': 'str',
        'vault': 'VaultRequest'
    }

    attribute_map = {
        'awssm': 'awssm',
        'azurekv': 'azurekv',
        'created_at': 'created_at',
        'created_by': 'created_by',
        'gcpsm': 'gcpsm',
        'humanitec': 'humanitec',
        'id': 'id',
        'primary': 'primary',
        'updated_at': 'updated_at',
        'updated_by': 'updated_by',
        'vault': 'vault'
    }

    def __init__(self, awssm=None, azurekv=None, created_at=None, created_by=None, gcpsm=None, humanitec=None, id=None, primary=None, updated_at=None, updated_by=None, vault=None):  # noqa: E501
        """SecretStoreRequest - a model defined in Swagger"""  # noqa: E501
        self._awssm = None
        self._azurekv = None
        self._created_at = None
        self._created_by = None
        self._gcpsm = None
        self._humanitec = None
        self._id = None
        self._primary = None
        self._updated_at = None
        self._updated_by = None
        self._vault = None
        self.discriminator = None
        if awssm is not None:
            self.awssm = awssm
        if azurekv is not None:
            self.azurekv = azurekv
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if gcpsm is not None:
            self.gcpsm = gcpsm
        if humanitec is not None:
            self.humanitec = humanitec
        if id is not None:
            self.id = id
        if primary is not None:
            self.primary = primary
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if vault is not None:
            self.vault = vault

    @property
    def awssm(self):
        """Gets the awssm of this SecretStoreRequest.  # noqa: E501


        :return: The awssm of this SecretStoreRequest.  # noqa: E501
        :rtype: AWSSMRequest
        """
        return self._awssm

    @awssm.setter
    def awssm(self, awssm):
        """Sets the awssm of this SecretStoreRequest.


        :param awssm: The awssm of this SecretStoreRequest.  # noqa: E501
        :type: AWSSMRequest
        """

        self._awssm = awssm

    @property
    def azurekv(self):
        """Gets the azurekv of this SecretStoreRequest.  # noqa: E501


        :return: The azurekv of this SecretStoreRequest.  # noqa: E501
        :rtype: AzureKVRequest
        """
        return self._azurekv

    @azurekv.setter
    def azurekv(self, azurekv):
        """Sets the azurekv of this SecretStoreRequest.


        :param azurekv: The azurekv of this SecretStoreRequest.  # noqa: E501
        :type: AzureKVRequest
        """

        self._azurekv = azurekv

    @property
    def created_at(self):
        """Gets the created_at of this SecretStoreRequest.  # noqa: E501


        :return: The created_at of this SecretStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this SecretStoreRequest.


        :param created_at: The created_at of this SecretStoreRequest.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this SecretStoreRequest.  # noqa: E501


        :return: The created_by of this SecretStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this SecretStoreRequest.


        :param created_by: The created_by of this SecretStoreRequest.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def gcpsm(self):
        """Gets the gcpsm of this SecretStoreRequest.  # noqa: E501


        :return: The gcpsm of this SecretStoreRequest.  # noqa: E501
        :rtype: GCPSMRequest
        """
        return self._gcpsm

    @gcpsm.setter
    def gcpsm(self, gcpsm):
        """Sets the gcpsm of this SecretStoreRequest.


        :param gcpsm: The gcpsm of this SecretStoreRequest.  # noqa: E501
        :type: GCPSMRequest
        """

        self._gcpsm = gcpsm

    @property
    def humanitec(self):
        """Gets the humanitec of this SecretStoreRequest.  # noqa: E501


        :return: The humanitec of this SecretStoreRequest.  # noqa: E501
        :rtype: HumanitecRequest
        """
        return self._humanitec

    @humanitec.setter
    def humanitec(self, humanitec):
        """Sets the humanitec of this SecretStoreRequest.


        :param humanitec: The humanitec of this SecretStoreRequest.  # noqa: E501
        :type: HumanitecRequest
        """

        self._humanitec = humanitec

    @property
    def id(self):
        """Gets the id of this SecretStoreRequest.  # noqa: E501


        :return: The id of this SecretStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SecretStoreRequest.


        :param id: The id of this SecretStoreRequest.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def primary(self):
        """Gets the primary of this SecretStoreRequest.  # noqa: E501


        :return: The primary of this SecretStoreRequest.  # noqa: E501
        :rtype: bool
        """
        return self._primary

    @primary.setter
    def primary(self, primary):
        """Sets the primary of this SecretStoreRequest.


        :param primary: The primary of this SecretStoreRequest.  # noqa: E501
        :type: bool
        """

        self._primary = primary

    @property
    def updated_at(self):
        """Gets the updated_at of this SecretStoreRequest.  # noqa: E501


        :return: The updated_at of this SecretStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this SecretStoreRequest.


        :param updated_at: The updated_at of this SecretStoreRequest.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this SecretStoreRequest.  # noqa: E501


        :return: The updated_by of this SecretStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this SecretStoreRequest.


        :param updated_by: The updated_by of this SecretStoreRequest.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def vault(self):
        """Gets the vault of this SecretStoreRequest.  # noqa: E501


        :return: The vault of this SecretStoreRequest.  # noqa: E501
        :rtype: VaultRequest
        """
        return self._vault

    @vault.setter
    def vault(self, vault):
        """Sets the vault of this SecretStoreRequest.


        :param vault: The vault of this SecretStoreRequest.  # noqa: E501
        :type: VaultRequest
        """

        self._vault = vault

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SecretStoreRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecretStoreRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
