# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UserRoleRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'role': 'str',
        'user': 'str',
        'created_at': 'str',
        'email': 'str',
        'id': 'str',
        'invite': 'str',
        'name': 'str',
        'type': 'str'
    }

    attribute_map = {
        'role': 'role',
        'user': 'user',
        'created_at': 'created_at',
        'email': 'email',
        'id': 'id',
        'invite': 'invite',
        'name': 'name',
        'type': 'type'
    }

    def __init__(self, role=None, user=None, created_at=None, email=None, id=None, invite=None, name=None, type=None):  # noqa: E501
        """UserRoleRequest - a model defined in Swagger"""  # noqa: E501
        self._role = None
        self._user = None
        self._created_at = None
        self._email = None
        self._id = None
        self._invite = None
        self._name = None
        self._type = None
        self.discriminator = None
        if role is not None:
            self.role = role
        if user is not None:
            self.user = user
        if created_at is not None:
            self.created_at = created_at
        if email is not None:
            self.email = email
        if id is not None:
            self.id = id
        if invite is not None:
            self.invite = invite
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type

    @property
    def role(self):
        """Gets the role of this UserRoleRequest.  # noqa: E501

        The role that this user holds  # noqa: E501

        :return: The role of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this UserRoleRequest.

        The role that this user holds  # noqa: E501

        :param role: The role of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._role = role

    @property
    def user(self):
        """Gets the user of this UserRoleRequest.  # noqa: E501

        The user ID that hold the role  # noqa: E501

        :return: The user of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this UserRoleRequest.

        The user ID that hold the role  # noqa: E501

        :param user: The user of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._user = user

    @property
    def created_at(self):
        """Gets the created_at of this UserRoleRequest.  # noqa: E501

        The time the user was first registered with Humanitec  # noqa: E501

        :return: The created_at of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this UserRoleRequest.

        The time the user was first registered with Humanitec  # noqa: E501

        :param created_at: The created_at of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def email(self):
        """Gets the email of this UserRoleRequest.  # noqa: E501

        The email address of the user from the profile  # noqa: E501

        :return: The email of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UserRoleRequest.

        The email address of the user from the profile  # noqa: E501

        :param email: The email of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def id(self):
        """Gets the id of this UserRoleRequest.  # noqa: E501

        The User ID for this user  # noqa: E501

        :return: The id of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserRoleRequest.

        The User ID for this user  # noqa: E501

        :param id: The id of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def invite(self):
        """Gets the invite of this UserRoleRequest.  # noqa: E501

        The status of an invitation (If applicable)  # noqa: E501

        :return: The invite of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._invite

    @invite.setter
    def invite(self, invite):
        """Sets the invite of this UserRoleRequest.

        The status of an invitation (If applicable)  # noqa: E501

        :param invite: The invite of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._invite = invite

    @property
    def name(self):
        """Gets the name of this UserRoleRequest.  # noqa: E501

        The name the user goes by  # noqa: E501

        :return: The name of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserRoleRequest.

        The name the user goes by  # noqa: E501

        :param name: The name of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this UserRoleRequest.  # noqa: E501

        The type of the account. Could be user, service or system  # noqa: E501

        :return: The type of this UserRoleRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this UserRoleRequest.

        The type of the account. Could be user, service or system  # noqa: E501

        :param type: The type of this UserRoleRequest.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserRoleRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserRoleRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
