# coding: utf-8

"""
    Humanitec API

    # Introduction The *Humanitec API* allows you to automate and integrate Humanitec into your developer and operational workflows. The API is a REST based API. It is based around a set of concepts:  * Core * External Resources * Sets and Deltas  ## Authentication Almost all requests made to the Humanitec API require Authentication. Humanitec provides 2 ways of authenticating with the API: `Bearer` and `JWT`.  ### Bearer Authentication This form of authentication makes use of a **static token**. It is intended to be used when machines interact with the Humanitec API. Bearer tokens should be used for very narrow purposes. This allows for the token to be revoked if it is compromised and so limit the scope of exposure. New Bearer tokens can be obtained via the UI:  1. Log into Humanitec at https://app.humanitec.io 1. Go to **Organization Settings** 1. Select **API tokens** 1. Enter a *name* for the new token and click on **Generate new token**  The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_TOKEN`, the request could be made as follows:  ```     curl -H 'Authorization: Bearer HUMANITEC_TOKEN' https://api.humanitec.io/orgs/my-org/apps ```  ### JWT Authentication This form of authentication makes use of a **JSON Web Token (JWT)**. It is intended to be used when humans interact with the Humanitec API. JWTs expire after a period of time. This means that a new JWT will need to be generated regularly. This makes them well suited to working in short sessions, but not for automation. (See Bearer Authentication.) The token is passed to the API via the `Authorization` header. Assuming the issued token is `HUMANITEC_JWT`, the request could be made as follows:  ```     curl -H 'Authorization: JWT HUMANITEC_JWT' https://api.humanitec.io/orgs/my-org/apps ```  ## Content Types All of the Humanitec API unless explicitly only accepts content types of `application/json` and will always return valid `application/json` or an empty response.  ## Response Codes ### Success Any response code in the `2xx` range should be regarded as success.  | **Code** | **Meaning** | | --- | --- | | `200` | Success | | `201` | Success (In future, `201` will be replaced by `200`) | | `204` | Success, but no content in response |  _Note: We plan to simplify the interface by replacing 201 with 200 status codes._  ### Failure Any response code in the `4xx` should be regarded as an error which can be rectified by the client. `5xx` error codes indicate errors that cannot be corrected by the client.  | **Code** | **Meaning** | | --- | --- | | `400` | General error. (Body will contain details) | | `401` | Attempt to access protected resource without `Authorization` Header. | | `403` | The `Bearer` or `JWT` does not grant access to the requested resource. | | `404` | Resource not found. | | `405` | Method not allowed | | `409` | Conflict. Usually indicated a resource with that ID already exists. | | `422` | Unprocessable Entity. The body was not valid JSON, was empty or contained an object different from what was expected. | | `429` | Too many requests - request rate limit has been reached. | | `500` | Internal Error. If it occurs repeatedly, contact support. |   # noqa: E501

    OpenAPI spec version: 0.24.1
    Contact: apiteam@humanitec.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ValuesSecretsRefsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'secret_refs': 'dict(str, object)',
        'secrets': 'dict(str, object)',
        'values': 'dict(str, object)'
    }

    attribute_map = {
        'secret_refs': 'secret_refs',
        'secrets': 'secrets',
        'values': 'values'
    }

    def __init__(self, secret_refs=None, secrets=None, values=None):  # noqa: E501
        """ValuesSecretsRefsRequest - a model defined in Swagger"""  # noqa: E501
        self._secret_refs = None
        self._secrets = None
        self._values = None
        self.discriminator = None
        if secret_refs is not None:
            self.secret_refs = secret_refs
        if secrets is not None:
            self.secrets = secrets
        if values is not None:
            self.values = values

    @property
    def secret_refs(self):
        """Gets the secret_refs of this ValuesSecretsRefsRequest.  # noqa: E501

        Secrets section of the data set. They can hold sensitive information that will be stored in the primary organization secret store and replaced with the secret store paths when sent outside, or secret references stored in a defined secret store. Can't be used together with `secrets`.  They can hold a nested structure but leaf objects need to be of type SecretReference, where:  - `store` is a Secret Store id. It can't be `humanitec`. It's mandatory if `ref` is defined and can't be used in request payloads if `value` is defined.  - `ref` is the secret key in the format of the target store. It can't be used in request payloads if `value` is defined.  - `version` is the version of the secret as defined in the target store. It can be defined only if `ref` is defined.  - `value` is the value to store in the organizations primary secret store. It can't be used in request payloads if `ref` is defined.  # noqa: E501

        :return: The secret_refs of this ValuesSecretsRefsRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._secret_refs

    @secret_refs.setter
    def secret_refs(self, secret_refs):
        """Sets the secret_refs of this ValuesSecretsRefsRequest.

        Secrets section of the data set. They can hold sensitive information that will be stored in the primary organization secret store and replaced with the secret store paths when sent outside, or secret references stored in a defined secret store. Can't be used together with `secrets`.  They can hold a nested structure but leaf objects need to be of type SecretReference, where:  - `store` is a Secret Store id. It can't be `humanitec`. It's mandatory if `ref` is defined and can't be used in request payloads if `value` is defined.  - `ref` is the secret key in the format of the target store. It can't be used in request payloads if `value` is defined.  - `version` is the version of the secret as defined in the target store. It can be defined only if `ref` is defined.  - `value` is the value to store in the organizations primary secret store. It can't be used in request payloads if `ref` is defined.  # noqa: E501

        :param secret_refs: The secret_refs of this ValuesSecretsRefsRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._secret_refs = secret_refs

    @property
    def secrets(self):
        """Gets the secrets of this ValuesSecretsRefsRequest.  # noqa: E501

        Secrets section of the data set. Sensitive information is stored in the primary organization secret store and replaced with the secret store paths when sent outside. Can't be used together with `secret_refs`.  # noqa: E501

        :return: The secrets of this ValuesSecretsRefsRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._secrets

    @secrets.setter
    def secrets(self, secrets):
        """Sets the secrets of this ValuesSecretsRefsRequest.

        Secrets section of the data set. Sensitive information is stored in the primary organization secret store and replaced with the secret store paths when sent outside. Can't be used together with `secret_refs`.  # noqa: E501

        :param secrets: The secrets of this ValuesSecretsRefsRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._secrets = secrets

    @property
    def values(self):
        """Gets the values of this ValuesSecretsRefsRequest.  # noqa: E501

        Values section of the data set. Passed around as-is.  # noqa: E501

        :return: The values of this ValuesSecretsRefsRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this ValuesSecretsRefsRequest.

        Values section of the data set. Passed around as-is.  # noqa: E501

        :param values: The values of this ValuesSecretsRefsRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._values = values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ValuesSecretsRefsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ValuesSecretsRefsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
